import request from '@/sheep/request';

const WithdrawalApi = {
  getWithdrawalPage: (params) => {
    return request({
      url: '/distri/application-for-withdrawal/page',
      method: 'GET',
      params,
      custom: {
        showLoading: false,
        showError: false,
      },
    });
  },
  // 获得提现比例
  getWithdrawalPercentage: (params) => {
    return request({
      url: '/distri/order-percentage/get',
      method: 'GET',
      params,
      custom: {
        showLoading: false,
        showError: false,
      },
    });
  },
  
};
export default WithdrawalApi;
