import request from '@/sheep/request';

export default {
    // 获得文章详情
    getArticle: (id, title) => {
        return request({
            url: '/promotion/article/get',
            method: 'GET',
            params: { id, title }
        });
    },
    // 获得文章列表
    getHomeList: () => {
        return request({
            url: '/promotion/article/getHomeInfo',
            method: 'GET'
        });
    },
	getArticleByCategory: (params) => {
        return request({
            url: '/promotion/article/page',
            method: 'GET',
            params
        });
    }
}
