import App from './App';
import { createSSRApp } from 'vue';
import { setupPinia } from './sheep/store';
import i18n from './locale';

function clearLinkId() {
  uni.removeStorageSync('linkId');
}
setInterval(clearLinkId, 300000);
export function createApp() {
  const app = createSSRApp(App);
  
  app.use(i18n);
  setupPinia(app);

  return {
    app,
  };
}
